//*****************************************************************************************************
//  1. t@C
//		MyMessageBox.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		bZ[W{bNX\
//----------------------------------------------------------------------------------------------------
//  3. l
//*****************************************************************************************************

#include "stdafx.h"
#include "resource.h"
#include "MyMessageBox.h"

// CMyMessageBox _CAO


IMPLEMENT_DYNAMIC(CMyMessageBox, CDialogEx)

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::CMyMessageBox
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd*	pParent		[I] eEBhE
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CMyMessageBox::CMyMessageBox(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMyMessageBox::IDD, pParent)
{
}

void CMyMessageBox::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_ICON, m_cStaticIcon);
	DDX_Control(pDX, IDC_STATIC_MESSAGE, m_cStaticMessage);
	DDX_Control(pDX, IDC_BUTTON1, m_cButton1);
	DDX_Control(pDX, IDC_BUTTON2, m_cButton2);
	DDX_Control(pDX, IDC_BUTTON3, m_cButton3);
}


BEGIN_MESSAGE_MAP(CMyMessageBox, CDialogEx)
	ON_BN_CLICKED(IDC_BUTTON1, &CMyMessageBox::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMyMessageBox::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMyMessageBox::OnBnClickedButton3)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CMyMessageBox bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUE
//*****************************************************************************************************
BOOL CMyMessageBox::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// bZ[W{bNX̃^Cgݒ
	SetWindowText(m_sTitle);

	// EBhẼTCY擾
	GetWindowRect(m_rectWindow);

	// NCAg̈̃TCY擾
	GetClientRect(m_rectClient);

	// e{^̈ʒuƃTCY擾
	m_cButton1.GetWindowRect(m_rectButton1);
	m_cButton2.GetWindowRect(m_rectButton2);
	m_cButton3.GetWindowRect(m_rectButton3);
	ScreenToClient(m_rectButton1);
	ScreenToClient(m_rectButton2);
	ScreenToClient(m_rectButton3);

	// bZ[WGÃTCY擾
	m_cStaticMessage.GetWindowRect(m_rectMessage);
	ScreenToClient(m_rectMessage);

	// ACRƃbZ[W\
	DispMessage();

	// [hXȂeEBhEDisable
	if (!m_bModal) {
		CWnd *pParent = GetParent();
		if (pParent != NULL)
			pParent->EnableWindow(FALSE);
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::DispMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ACRƃbZ[W\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::DispMessage()
{
	// EBhEJĂȂΉȂ
	if (m_hWnd == NULL)
		return;

	// ACR擾
	HICON hIcon;
	switch (m_nType & 0xf0) {
	case MB_ICONEXCLAMATION:
		hIcon = AfxGetApp()->LoadStandardIcon(IDI_EXCLAMATION);
		break;
	case MB_ICONINFORMATION:
		hIcon = AfxGetApp()->LoadStandardIcon(IDI_INFORMATION);
		break;
	case MB_ICONQUESTION:
		hIcon = AfxGetApp()->LoadStandardIcon(IDI_QUESTION);
		break;
	case MB_ICONSTOP:
		hIcon = AfxGetApp()->LoadStandardIcon(IDI_ERROR);
		break;
	default:
		hIcon = NULL;
		break;
	}

	// ACR\
	if (hIcon != NULL)
		m_cStaticIcon.SetIcon(hIcon);

	// {^̎ނ擾
	LPCTSTR pButton1, pButton2, pButton3;
	switch (m_nType & 0x0f) {
	case MB_ABORTRETRYIGNORE:	// [~]A[Ďs]A[]
		pButton1 = "@~";
		pButton2 = "Ďs";
		pButton3 = "@";

		m_nButton1 = IDABORT;
		m_nButton2 = IDRETRY;		
		m_nButton3 = IDIGNORE;
		break;
	case MB_OK:	// [OK]
		pButton1 = "@";
		pButton2 = NULL;
		pButton3 = NULL;

		m_nButton1 = IDOK;
		break;
	case MB_OK_END:	// [OK]
		pButton1 = "I@";
		pButton2 = NULL;
		pButton3 = NULL;

		m_nButton1 = IDOK;
		break;
	case MB_OKCANCEL:	// [OK]A[LZ]
		pButton1 = "@";
		pButton2 = "@";
		pButton3 = NULL;

		m_nButton1 = IDOK;
		m_nButton2 = IDCANCEL;
		break;
	case MB_OIL:		// [OK]A[LZ]@Ɩ̕[ʃo[W
		pButton1 = "[s";
		pButton2 = " @ ";
		pButton3 = NULL;

		m_nButton1 = IDOK;
		m_nButton2 = IDCANCEL;
		break;
	case MB_RETRYCANCEL:	// [Ďs]A[LZ]
		pButton1 = "Ďs";
		pButton2 = "@";
		pButton3 = NULL;

		m_nButton1 = IDRETRY;
		m_nButton2 = IDCANCEL;
		break;
	case MB_YESNO:	// [͂]A[]
		pButton1 = "́@";
		pButton2 = "";
		pButton3 = NULL;

		m_nButton1 = IDYES;
		m_nButton2 = IDNO;
	case MB_YESNOCANCEL:	// [͂]A[]A[LZ]
		pButton1 = "́@";
		pButton2 = "";
		pButton3 = "@";

		m_nButton1 = IDYES;
		m_nButton2 = IDNO;		
		m_nButton3 = IDCANCEL;
		break;
	}

	// {^̃TCY擾
	CSize sizeButton(m_rectButton1.Width(), m_rectButton1.Height());

	// {^̊Ԃ̃Xy[X擾
	int nButtonSpace = m_rectButton2.left - m_rectButton1.right;

	// {^̍̃Xy[X擾
	int nLeftSpace = m_rectButton1.left;

	// {^̉ẼXy[X擾
	int nRightSpace = nLeftSpace;

	// SẴ{^ŏ̃EBhETCYvZ
	CSize sizeWindowButton(nLeftSpace + sizeButton.cx + nRightSpace, m_rectWindow.Height());
	if (pButton2 != NULL)
		sizeWindowButton.cx += sizeButton.cx + nButtonSpace;
	if (pButton3 != NULL)
		sizeWindowButton.cx += sizeButton.cx + nButtonSpace;

	// bZ[W̃TCY擾
	CRect rectText(0, 0, 0, 0);
	CDC *pDC = GetWindowDC();
	CFont *pFontOrg = pDC->SelectObject(GetFont());
	pDC->DrawText(m_sMessage, rectText, DT_CALCRECT);
	pDC->SelectObject(pFontOrg);
	ReleaseDC(pDC);

	// SẴbZ[Wŏ̃EBhETCYvZ
	CSize sizeWindowText;
	sizeWindowText.cx = m_rectWindow.Width() + rectText.Width() - m_rectMessage.Width();
	sizeWindowText.cy = m_rectWindow.Height() + rectText.Height() - m_rectMessage.Height();

	// bZ[W̃TCYɂEBhETCYg
	CSize sizeWindow(max(sizeWindowButton.cx, sizeWindowText.cx), max(sizeWindowButton.cy, sizeWindowText.cy));

	// EBhËʒuƃTCY𒲐
	SetWindowPos(NULL, 0, 0, sizeWindow.cx, sizeWindow.cy, SWP_NOZORDER | SWP_NOMOVE);
	CenterWindow();

	// bZ[W̃TCY𒲐
	m_cStaticMessage.SetWindowPos(NULL, 0, 0, rectText.right, rectText.bottom, SWP_NOMOVE | SWP_NOZORDER);

	// bZ[W\
	m_cStaticMessage.SetWindowText(m_sMessage);

	// {^̈ʒuvZ
	CPoint pointButton;
	pointButton.x = nLeftSpace + (sizeWindow.cx - sizeWindowButton.cx) / 2;
	pointButton.y = m_rectButton1.top + sizeWindow.cy - m_rectWindow.Height();

	// PԖڂ̃{^\
	m_cButton1.SetWindowPos(NULL, pointButton.x, pointButton.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
	m_cButton1.SetWindowText(pButton1);

	// QԖڂ̃{^\
	if (pButton2 != NULL) {
		pointButton.x += sizeButton.cx + nButtonSpace;
		m_cButton2.SetWindowPos(NULL, pointButton.x, pointButton.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_cButton2.SetWindowText(pButton2);
		m_cButton2.ShowWindow(SW_SHOW);
	} else
		m_cButton2.ShowWindow(SW_HIDE);

	// RԖڂ̃{^\
	if (pButton3 != NULL) {
		pointButton.x += sizeButton.cx + nButtonSpace;
		m_cButton3.SetWindowPos(NULL, pointButton.x, pointButton.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_cButton3.SetWindowText(pButton3);
		m_cButton3.ShowWindow(SW_SHOW);
	} else
		m_cButton3.ShowWindow(SW_HIDE);
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::MessageBox
//----------------------------------------------------------------------------------------------------
//  2. @\
//		[_bZ[W{bNX\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR	lpszText		[I] \bZ[W
//		LPCTSTR	lpszCaption		[I] EBhE^Cg
//		UINT	nType			[I] ACRƃ{^̎
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
int CMyMessageBox::MessageBox(LPCTSTR lpszText, LPCTSTR lpszCaption, UINT nType)
{
	m_sMessage = lpszText;
	m_sTitle = lpszCaption;
	m_nType = nType;
	m_bModal = TRUE;

	if (m_sTitle=="")
		m_sTitle=::AfxGetAppName();

	return (int)DoModal();
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::ModelessMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		[hXbZ[W{bNX\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd	*pWnd			[I] eEBhE
//		LPCTSTR	lpszText		[I] \bZ[W
//		LPCTSTR	lpszCaption		[I] EBhE^Cg
//		UINT	nType			[I] ACRƃ{^̎
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::ModelessMessage(CWnd *pWnd, LPCTSTR lpszText, LPCTSTR lpszCaption, UINT nType)
{
	m_sMessage = lpszText;
	m_sTitle = lpszCaption;
	m_nType = nType;
	m_bModal = FALSE;

	if (m_sTitle=="")
		m_sTitle=::AfxGetAppName();

	// [hXŃ_CAOJ
	DoModeless(pWnd);
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::ChangeMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		bZ[WύX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR	lpszText		[I] \bZ[W
//		UINT	nType			[I] ACRƃ{^̎
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::ChangeMessage(LPCTSTR lpszText, UINT nType)
{
	m_sMessage = lpszText;
	m_nType = nType;

	DispMessage();
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::CloseMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		bZ[W{bNXN[Y
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::CloseMessage()
{
	if (m_hWnd != NULL)
		EndDialog(IDCANCEL);
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::OnBnClickedButton1
//----------------------------------------------------------------------------------------------------
//  2. @\
//		P{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::OnBnClickedButton1()
{
	ClickedButton(m_nButton1);
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::OnBnClickedButton2
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Q{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::OnBnClickedButton2()
{
	ClickedButton(m_nButton2);
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::OnBnClickedButton3
//----------------------------------------------------------------------------------------------------
//  2. @\
//		R{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::OnBnClickedButton3()
{
	ClickedButton(m_nButton3);
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::ClickedButton
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nButton		[I] NbN{^ID
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::ClickedButton(int nButton)
{
	if (m_bModal)
		EndDialog(nButton);
	else {
		// eEBhEɉꂽ{^ʒm
		CWnd *pParent = GetParent();
		if (pParent != NULL)
			pParent->PostMessage(WM_MY_MESSAGE_BOX, nButton);

		// EBhE
		DestroyWindow();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::OnCancel
//----------------------------------------------------------------------------------------------------
//  2. @\
//		LZ{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::OnCancel()
{
	ClickedButton(IDCANCEL);
}

//*****************************************************************************************************
//  1. ֐
//		CMyMessageBox::OnDestroy
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMyMessageBox::OnDestroy()
{
	CDialogEx::OnDestroy();

	// [hXȂeEBhEEnableɂ
	if (!m_bModal) {
		CWnd *pParent = GetParent();
		if (pParent != NULL)
			pParent->EnableWindow(TRUE);
	}
}
